chiark / gitweb /
more wip, including config stuff
[dgit.git] / dgit
diff --git a/dgit b/dgit
index b3f059e6ac8a1aa8fbee7ba85f2e6751334aa2c8..60138fea122567892caad6d4b352727d37fda25d 100755 (executable)
--- a/dgit
+++ b/dgit
@@ -26,8 +26,6 @@ use Dpkg::Control::Hash;
 use File::Path;
 use POSIX;
 
-open DEBUG, ">&STDERR" or die $!;
-
 our $mirror = 'http://mirror.relativity.greenend.org.uk/mirror/debian-ftp/';
 our $suite = 'sid';
 our $package;
@@ -36,10 +34,7 @@ our $sign = 1;
 our $dryrun = 0;
 our $changesfile;
 
-our $aliothname = 'iwj@git.debian.org';
-our $aliothpath = '/git/dgit-test';
-our $alioth_git = "git+ssh://$aliothname/$aliothpath";
-our $alioth_sshtestbodge = [$aliothname,$aliothpath];
+our %format_ok = map { $_=>1 } ("1.0","3.0 (native)","3.0 (quilt)");
 
 our (@git) = qw(git);
 our (@dget) = qw(dget);
@@ -47,19 +42,28 @@ our (@dput) = qw(dput);
 our (@debsign) = qw(debsign);
 our $keyid;
 
-our %opts_opt_map = ('dg' => \@dget,
-                    'dp' => \@dput,
-                    'ds' => \@debsign);
+open DEBUG, ">/dev/null" or die $!;
+
+our %opts_opt_map = ('dget' => \@dget,
+                    'dput' => \@dput,
+                    'debsign' => \@debsign);
 
 our $remotename = 'dgit';
-our $ourdscfield = 'Vcs-git-master';
+our $ourdscfield = 'Vcs-Git-Master';
 our $branchprefix = 'dgit';
 
-sub uploadbranch () { return "$branchprefix/$suite"; }
-sub lref ($) { return "refs/heads/$_[0]"; }
-sub rref ($) { return "refs/remotes/$remotename/$_[0]"; }
+sub lbranch () { return "$branchprefix/$suite"; }
+my $lbranch_re = '^refs/heads/'.$branchprefix.'/([^/.]+)$';
+sub lref () { return "refs/heads/".lbranch(); }
+sub lrref () { return "refs/remotes/$remotename/$suite"; }
+sub rrref () { return "refs/$branchprefix/$suite"; }
 sub debiantag ($) { return "debian/$_[0]"; }
 
+sub fetchspec () {
+    local $suite = '*';
+    return  "+".rrref().":".lrref();
+}
+
 our $ua;
 
 sub url_get {
@@ -67,7 +71,7 @@ sub url_get {
        $ua = LWP::UserAgent->new();
        $ua->env_proxy;
     }
-    print DEBUG "fetching @_...\n";
+    print "downloading @_...\n";
     my $r = $ua->get(@_) or die $!;
     die "$_[0]: ".$r->status_line."; failed.\n" unless $r->is_success;
     return $r->decoded_content();
@@ -75,12 +79,31 @@ sub url_get {
 
 our ($dscdata,$dscurl,$dsc);
 
+sub printcmd {
+    my $fh = shift @_;
+    my $intro = shift @_;
+    print $fh $intro or die $!;
+    local $_;
+    foreach my $a (@_) {
+       $_ = $a;
+       if (s{['\\]}{\\$&}g || m{\s} || m{[^-_./0-9a-z]}i) {
+           print $fh " '$_'" or die $!;
+       } else {
+           print $fh " $_" or die $!;
+       }
+    }
+    print $fh "\n" or die $!;
+}
+
 sub runcmd {
+    printcmd(\*DEBUG,"+",@_);
     $!=0; $?=0;
     die "@_ $! $?" if system @_;
 }
 
 sub cmdoutput_errok {
+    die Dumper(\@_)." ?" if grep { !defined } @_;
+    printcmd(\*DEBUG,"|",@_);
     open P, "-|", @_ or die $!;
     my $d;
     $!=0; $?=0;
@@ -98,17 +121,7 @@ sub cmdoutput {
 }
 
 sub dryrun_report {
-    print "#" or die $!;
-    local $_;
-    foreach my $a (@_) {
-       $_ = $a;
-       if (s{['\\]}{\\$&}g || m{\s} || m{[^-_./0-9a-z]}i) {
-           print " '$_'" or die $!;
-       } else {
-           print " $_" or die $!;
-       }
-    }
-    print "\n" or die $!;
+    printcmd(\*STDOUT,"#",@_);
 }
 
 sub runcmd_ordryrun {
@@ -119,6 +132,56 @@ sub runcmd_ordryrun {
     }
 }
 
+our %defcfg = ('dgit.default.distro' => 'debian',
+              'dgit.default.username' => '',
+              'dgit.default.ssh' => 'ssh',
+              'dgit-distro.debian.git-host' => 'git.debian.org',
+              'dgit-distro.debian.git-proto' => 'git+ssh://',
+              'dgit-distro.debian.git-path' => '/git/dgit-repos',
+              'dgit-distro.debian.git-check' => 'ssh-cmd',
+              'dgit-distro.debian.git-create' => 'ssh-cmd');
+
+sub cfg {
+    foreach my $c (@_) {
+       my $v = cmdoutput_errok(qw(git config --), $c);
+       if ($?==0) {
+           chomp $v;
+           return $v;
+       } elsif ($?!=256) {
+           die "$c $?";
+       }
+       my $dv = $defcfg{$c};
+       return $dv if defined $dv;
+    }
+    return undef;
+}
+
+sub access_cfg ($) {
+    my ($key) = @_;
+    my $distro = cfg("dgit-suite.$suite.distro",
+                    "dgit.default.distro");
+    my $value = cfg("dgit-distro.$distro.$key",
+                   "dgit.default.$key");
+    return $value;
+}
+
+sub access_gituserhost () {
+    my $user = access_cfg('git-user');
+    my $host = access_cfg('git-host');
+    return defined($user) && length($user) ? "$user\@$host" : $host;
+}
+
+sub access_giturl ($) {
+    my $url = access_cfg('git-url');
+    if (!defined $url) {
+       $url =
+           access_cfg('git-proto').
+           access_gituserhost().
+           access_cfg('git-path');
+    }
+    return "$url/package.git";
+}             
+
 sub parsecontrol {
     my $c = Dpkg::Control::Hash->new();
     $c->load(@_) or return undef;
@@ -134,44 +197,72 @@ sub parsechangelog {
     return $c;
 }
 
-sub get_archive_dsc () {
-    my $rmad = cmdoutput qw(rmadison -asource),"-s$suite",$package;
+our $rmad;
+
+sub askmadison () {
+    $rmad ||= cmdoutput qw(rmadison -asource),"-s$suite",$package;
     $rmad =~ m/^ \s*( [^ \t|]+ )\s* \|
                  \s*( [^ \t|]+ )\s* \|
                  \s*( [^ \t|]+ )\s* \|
                  \s*( [^ \t|]+ )\s* /x or die "$rmad $?";
     $1 eq $package or die "$rmad $package ?";
     my $vsn = $2;
-    $3 eq $suite or die "$rmad $suite ?";
+    if ($suite ne $3) {
+       # madison canonicalises for us
+       print "canonical suite name for $suite is $3\n";
+       $suite = $3;
+    }
     $4 eq 'source' or die "$rmad ?";
-    # fixme it does not show us the component ?
+    return $vsn;
+}
+
+sub canonicalise_suite () {
+    askmadison();
+}
+
+sub get_archive_dsc () {
+    my $vsn = askmadison();
+    # fixme madison does not show us the component
     my $prefix = substr($package, 0, $package =~ m/^l/ ? 4 : 1);
     $dscurl = "$mirror/pool/main/$prefix/$package/${package}_$vsn.dsc";
-#print DEBUG Dumper($pdodata, $&, $dscurl);
     $dscdata = url_get($dscurl);
     my $dscfh = new IO::File \$dscdata, '<' or die $!;
-#print DEBUG Dumper($dscdata, $dscfh);
+    print DEBUG Dumper($dscdata);
     $dsc = Dpkg::Control::Hash->new(allow_pgp=>1);
     $dsc->parse($dscfh, 'dsc') or die "parsing of $dscurl failed\n";
-#print DEBUG Dumper($dsc);
+    print DEBUG Dumper($dsc);
     my $fmt = $dsc->{Format};
-    die "unsupported format $fmt, sorry\n" unless $fmt eq '1.0';
+    die "unsupported format $fmt, sorry\n" unless $format_ok{$fmt};
 }
 
 sub check_for_git () {
     # returns 0 or 1
-    my $cmd= 
-       "ssh $alioth_sshtestbodge->[0] '".
-       " set -e; cd $aliothpath;".
-       " if test -d $package.git; then echo 1; else echo 0; fi".
-       "'";
-    #print DEBUG "$cmd\n";
-    open P, "$cmd |" or die $!;
-    $!=0; $?=0;
-    my $r = <P>; close P;
-#print STDERR ">$r<\n";
-    die "$r $! $?" unless $r =~ m/^[01]$/;
-    return $r+0;
+    my $how = access_cfg('git-check');
+    if ($how eq 'ssh-cmd') {
+       my $r= cmdoutput
+           (access_cfg('ssh'),access_gituserhost(),
+            " set -e; cd ".access_cfg('git-path').";".
+            " if test -d $package.git; then echo 1; else echo 0; fi");
+       print DEBUG ">$r<\n";
+       die "$r $! $?" unless $r =~ m/^[01]$/;
+       return $r+0;
+    } else {
+       die "unknown git-check $how ?";
+    }
+}
+
+sub create_remote_git_repo () {
+    my $how = access_cfg('git-create');
+    if ($how eq 'ssh-cmd') {
+       runcmd_ordryrun
+           (access_cfg('ssh'),access_gituserhost(),
+            "set -e; cd ".access_cfg('git-path').";".
+            " mkdir -p $package.git;".
+            " cd $package.git;".
+            " if ! test -d objects; then git init --bare; fi");
+    } else {
+       die "unknown git-create $how ?";
+    }
 }
 
 our ($dsc_hash,$upload_hash);
@@ -211,7 +302,7 @@ sub dsc_files () {
 
 sub is_orig_file ($) {
     local ($_) = @_;
-    m/\.orig\.tar\.\w+$/;
+    m/\.orig(?:-\w+)?\.tar\.\w+$/;
 }
 
 sub generate_commit_from_dsc () {
@@ -251,8 +342,8 @@ $clogp->{Changes}
 # imported by dgit from the archive
 END
     close C or die $!;
-    print "synthesised git commit from .dsc $clogp->{Version}\n";
     my $commithash = cmdoutput @git, qw(hash-object -w -t commit ../commit.tmp);
+    print "synthesised git commit from .dsc $clogp->{Version}\n";
     chdir '../../../..' or die $!;
     cmdoutput @git, qw(update-ref -m),"dgit synthesise $clogp->{Version}",
               'DGIT_ARCHIVE', $commithash;
@@ -305,7 +396,7 @@ sub ensure_we_have_orig () {
 }
 
 sub rev_parse ($) {
-    return cmdoutput @git, qw(rev-parse --), "$_[0]~0";
+    return cmdoutput @git, qw(rev-parse), "$_[0]~0";
 }
 
 sub is_fast_fwd ($$) {
@@ -314,15 +405,33 @@ sub is_fast_fwd ($$) {
     return rev_parse($mb) eq rev_parse($ancestor);
 }
 
+sub git_fetch_us () {
+    die "cannot dry run with fetch" if $dryrun;
+    runcmd @git, qw(fetch),$remotename,fetchspec();
+}
+
 sub fetch_from_archive () {
-    # ensures that rref(uploadbranch()) is what is actually in the archive,
+    # ensures that lrref() is what is actually in the archive,
     #  one way or another
-    my $upload_ref = rref(uploadbranch());
+    get_archive_dsc();
+    $dsc_hash = $dsc->{$ourdscfield};
+    if (defined $dsc_hash) {
+       $dsc_hash =~ m/\w+/ or die "$dsc_hash $?";
+       $dsc_hash = $&;
+       print "last upload to archive specified git hash\n";
+    } else {
+       print "last upload to archive has NO git hash\n";
+    }
+
     $!=0; $upload_hash =
-       cmdoutput_errok @git, qw(show-ref --heads), $upload_ref;
-    die $! if $!;
-    die $? unless ($?==0 && chomp $upload_hash) 
-       or ($?==256 && !length $upload_hash);
+       cmdoutput_errok @git, qw(show-ref --heads), lrref();
+    if ($?==0) {
+       die unless chomp $upload_hash;
+    } elsif ($?==256) {
+       $upload_hash = '';
+    } else {
+       die $?;
+    }
     my $hash;
     if (defined $dsc_hash) {
        die "missing git history even though dsc has hash"
@@ -338,7 +447,7 @@ sub fetch_from_archive () {
            unless is_fast_fwd($dsc_hash, $upload_hash);
     }
     if ($upload_hash ne $hash) {
-       my @upd_cmd = (@git, qw(update-ref -m), 'dgit fetch', $upload_ref, $hash);
+       my @upd_cmd = (@git, qw(update-ref -m), 'dgit fetch', lrref(), $hash);
        if (!$dryrun) {
            cmdoutput @upd_cmd;
        } else {
@@ -347,48 +456,32 @@ sub fetch_from_archive () {
     }
 }
 
-sub clone () {
+sub clone ($) {
+    my ($dstdir) = @_;
     die "dry run makes no sense with clone" if $dryrun;
-    get_archive_dsc();
-    $dsc_hash = $dsc->{$ourdscfield};
-    if (defined $dsc_hash) {
-       $dsc_hash =~ m/\w+/ or die "$dsc_hash $?";
-       $dsc_hash = $&;
-       print "last upload to archive specified git hash\n";
-    } else {
-       print "last upload to archive has NO git hash\n";
-    }
-    my $dstdir = "$package";
-    my $branch = uploadbranch();
+    mkdir $dstdir or die "$dstdir $!";
+    chdir "$dstdir" or die "$dstdir $!";
+    runcmd @git, qw(init -q);
+    runcmd @git, qw(config), "remote.$remotename.fetch", fetchspec();
+    open H, "> .git/HEAD" or die $!;
+    print H "ref: ".lref()."\n" or die $!;
+    close H or die $!;
+    runcmd @git, qw(remote add), 'origin', access_giturl($package);
     if (check_for_git()) {
-       print "cloning existing git history\n";
-       runcmd @git, qw(clone --origin),$remotename, qw(-b), $branch, '--',
-           "$alioth_git/$package.git", $dstdir;
-       chdir "$dstdir" or die "$dstdir $!";
-       fetch_from_archive();
-       runcmd @git, qw(reset --hard), rref(uploadbranch());
+       print "fetching existing git history\n";
+       git_fetch_us();
+       runcmd @git, qw(fetch origin);
     } else {
        print "starting new git history\n";
-       mkdir $dstdir or die "$dstdir $!";
-       chdir "$dstdir" or die "$dstdir $!";
-       runcmd @git, qw(init -q);
-       open H, "> .git/HEAD" or die $!;
-       print H "ref: ".lref(uploadbranch())."\n" or die $!;
-       close H or die $!;
-       runcmd @git, qw(remote add), $remotename, "$alioth_git/$package.git";
-       runcmd "git config branch.$branch.remote $remotename";
-       runcmd "git config branch.$branch.merge ".lref(uploadbranch());
-       my $newhash = generate_commit_from_dsc();
-       runcmd @git, qw(reset --hard), $newhash;
     }
+    fetch_from_archive();
+    runcmd @git, qw(reset --hard), lrref();
     print "ready for work in $dstdir\n";
 }
 
 sub fetch () {
-    get_archive_dsc();
     if (check_for_git()) {
-       runcmd_ordryrun @git, qw(fetch -p),$remotename,
-           '+refs/heads/*:refs/remotes/origin/*';
+       git_fetch_us();
     }
     fetch_from_archive();
 }
@@ -396,12 +489,13 @@ sub fetch () {
 sub pull () {
     fetch();
     runcmd_ordryrun @git, qw(merge -m),"Merge from $suite [dgit]",
-        lref(uploadbranch());
+        lrref();
 }
 
 sub dopush () {
     runcmd @git, qw(diff --quiet HEAD);
     my $clogp = parsechangelog();
+    die if defined $package;
     $package = $clogp->{Source};
     my $dscfn = "${package}_$clogp->{Version}.dsc";
     stat "../$dscfn" or die "$dscfn $!";
@@ -421,42 +515,59 @@ sub dopush () {
 #        (uploadbranch());
     $dsc->{$ourdscfield} = rev_parse('HEAD');
     $dsc->save("../$dscfn.tmp") or die $!;
-    rename "../$dscfn.tmp","../$dscfn" or die "$dscfn $!";
+    if (!$dryrun) {
+       rename "../$dscfn.tmp","../$dscfn" or die "$dscfn $!";
+    } else {
+       print "[new .dsc left in $dscfn.tmp]\n";
+    }
     if (!$changesfile) {
        my $pat = "../${package}_$clogp->{Version}_*.changes";
-       my @cs = <$pat>;
+       my @cs = glob $pat;
         die "$pat ?" unless @cs==1;
-       ($changesfile) = $cs;
+       ($changesfile) = @cs;
+    }
+    my $tag = debiantag($dsc->{Version});
+    if (!check_for_git()) {
+       create_remote_git_repo();
     }
+    runcmd_ordryrun @git, qw(push),$remotename,"HEAD:".rrref();
     if ($sign) {
-       my @tag_cmd = @git, qw(tag -s -m),
-           "Release $dsc->{Version} for $suite [dgit]";
+       my @tag_cmd = (@git, qw(tag -s -m),
+                      "Release $dsc->{Version} for $suite [dgit]");
        push @tag_cmd, qw(-u),$keyid if defined $keyid;
+       push @tag_cmd, $tag;
        runcmd_ordryrun @tag_cmd;
        my @debsign_cmd = @debsign;
        push @debsign_cmd, "-k$keyid" if defined $keyid;
-       push @debsign_cmd, "../$changesfile";
-       runcmd_ordryrun qw(debsign);
+       push @debsign_cmd, $changesfile;
+       runcmd_ordryrun @debsign_cmd;
     }
-    runcmd_ordryrun @git, qw(push),$remotename,"HEAD:".lref(uploadbranch());
-    runcmd_ordryrun @dput, "../$dscfn";
+    runcmd_ordryrun @git, qw(push),$remotename,"refs/tags/$tag";
+    runcmd_ordryrun @dput, $changesfile;
 }
 
 sub cmd_clone {
+    my $dstdir;
+    die if defined $package;
     if (@ARGV==1) {
        ($package) = @ARGV;
-    } elsif (@ARGV==2) {
+    } elsif (@ARGV==2 && $ARGV[1] =~ m#^\w#) {
        ($package,$suite) = @ARGV;
+    } elsif (@ARGV==2 && $ARGV[1] =~ m#^[./]#) {
+       ($package,$dstdir) = @ARGV;
+    } elsif (@ARGV==3) {
+       ($package,$suite,$dstdir) = @ARGV;
     } else {
        die;
     }
-    clone();
+    $dstdir ||= "$package";
+    clone($dstdir);
 }
 
 sub branchsuite () {
-    my $branch = cmdoutput_errok @git, qw(symbolic-ref);
+    my $branch = cmdoutput_errok @git, qw(symbolic-ref HEAD);
     chomp $branch;
-    if ($branch =~ m#^refs/heads/$branchprefix/([^/.]+)$#o) {
+    if ($branch =~ m#$lbranch_re#o) {
        return $1;
     } else {
        return undef;
@@ -464,14 +575,21 @@ sub branchsuite () {
 }
 
 sub fetchpullargs () {
-    my $clogp = parsechangelog();
-    $package = $clogp->{Source};
+    if (!defined $package) {
+       my $sourcep = parsecontrol('debian/control');
+       $package = $sourcep->{Source};
+    }
     if (@ARGV==0) {
        $suite = branchsuite();
-       $suite ||= $clogp->{Distribution};
+       if (!$suite) {
+           my $clogp = parsechangelog();
+           $suite = $clogp->{Distribution};
+       }
+       canonicalise_suite();
        print "fetching from suite $suite\n";
     } elsif (@ARGV==1) {
        ($suite) = @ARGV;
+       canonicalise_suite();
     } else {
        die;
     }
@@ -488,10 +606,12 @@ sub cmd_pull {
 }
 
 sub cmd_push {
+    die if defined $package;
     my $clogp = parsechangelog();
     $package = $clogp->{Source};
     if (@ARGV==0) {
        $suite = $clogp->{Distribution};
+       canonicalise_suite();
     } else {
        die;
     }
@@ -499,24 +619,32 @@ sub cmd_push {
 }
 
 sub cmd_build {
+    die if defined $package;
     my $clogp = parsechangelog();
     $suite = $clogp->{Distribution};
-    runcmd_dryrun
+    $package = $clogp->{Source};
+    canonicalise_suite();
+    runcmd_ordryrun
        qw(git-buildpackage -us -uc --git-no-sign-tags),
-        "--git-debian-branch=".uploadbranch(),
-        @ARGV;
+            "--git-debian-branch=".lbranch(),
+            @ARGV;
 }
 
 sub parseopts () {
+    my $om;
     while (@ARGV) {
-       last unless $ARGV[0];
+       last unless $ARGV[0] =~ m/^-/;
        $_ = shift @ARGV;
        last if m/^--?$/;
        if (m/^--/) {
-           if (m/^--dry-run/) {
+           if (m/^--dry-run$/) {
                $dryrun=1;
-           if (m/^--no-sign/) {
+           } elsif (m/^--no-sign$/) {
                $sign=0;
+           } elsif (m/^--(\w+)=(.*)/s && ($om = $opts_opt_map{$1})) {
+               $om->[0] = $2;
+           } elsif (m/^--(\w+):(.*)/s && ($om = $opts_opt_map{$1})) {
+               push @$om, $2;
            } else {
                die "$_ ?";
            }
@@ -524,22 +652,14 @@ sub parseopts () {
            while (m/^-./s) {
                if (s/^-n/-/) {
                    $dryrun=1;
-               } elsif (s/^-p(.*)//s) {
-                   $gpg[0] = $1;
+               } elsif (s/^-D/-/) {
+                   open DEBUG, ">&STDERR" or die $!;
                } elsif (s/^-c(.*=.*)//s) {
                    push @git, $1;
                } elsif (s/^-C(.*)//s) {
                    $changesfile = $1;
                } elsif (s/^-k(.*)//s) {
                    $keyid=$1;
-               } elsif (s/^-:(\w+)(.*)//s) {
-                   my $om = $opts_opt_map{$1};
-                   die "$1" unless defined $om;
-                   $om->[0] = $1;
-               } elsif (s/^-,(\w+)(.*)//s) {
-                   my $om = $opts_opt_map{$1};
-                   die "$1" unless defined $om;
-                   push @$om, $1;
                } else {
                    die "$_ ?";
                }